local gsub = gsub
local format = format
local strsub = strsub
local strfind = strfind
local strmatch = strmatch
local KeystoneDepleted = CHALLENGE_MODE_KEYSTONE_DEPLETED
local DungeonName, DungeonLevel, IsDepleted

local KeystoneTooltip = CreateFrame("GameTooltip", "KeystoneLinkPlusTooltip", UIParent, "GameTooltipTemplate")
local Line1 = KeystoneLinkPlusTooltipTextLeft1
local Line2 = KeystoneLinkPlusTooltipTextLeft2
local Line3 = KeystoneLinkPlusTooltipTextLeft3

KeystoneTooltip:HookScript("OnTooltipSetItem", function(self)
	DungeonName = Line1:GetText()
	
	if strmatch(Line2:GetText(), KeystoneDepleted) then
		IsDepleted = true
		DungeonLevel = strmatch(Line3:GetText(), "%d+")
	else
		DungeonLevel = strmatch(Line2:GetText(), "%d+")
	end
end)

local ReformatKeys = function(self, event, msg, ...)
	if strfind(msg, "\124Hitem:138019:") then -- A keystone!
		-- If someone better with string manipulation can do this in a cleaner fashion, I'm not ashamed to take help!
		local ItemLinkStart, ItemLinkStop = strfind(msg, "\124cffa335ee\124Hitem:138019:([0-9:]+)\124h(.-)\124h\124r")
		local ItemLink = strsub(msg, ItemLinkStart, ItemLinkStop)
		local ItemLinkString = strmatch(ItemLink, "\124H(.-)\124h")
		local KeyName = strmatch(ItemLink, "\124h%[(.-)%]\124h")
		
		if (ItemLink and ItemLinkString) then
			local LinkName
			DungeonName = nil
			DungeonLevel = nil
			IsDepleted = nil
			
			KeystoneTooltip:SetHyperlink(ItemLinkString)
			
			if IsDepleted then
				LinkName = format("%s %s (%s)", DungeonName, DungeonLevel, KeystoneDepleted)
			else
				LinkName = format("%s %s", DungeonName, DungeonLevel)
			end
			
			msg = gsub(msg, KeyName, LinkName)
			
			return false, msg, ...
		end
	end
end

ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_GUILD", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_INSTANCE", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_INSTANCE_LEADER", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY_LEADER", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_WHISPER", ReformatKeys)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_WHISPER_INFORM", ReformatKeys)